*******************************************************************
* Ownerdrawing, Beispiel 6:
* Jetzt das ganze mit einer eigenen Klasse
* ::DrawMode wird nur noch in der Klasse gesetzt
* Hervorhebung aktiver Zellen in gewhlter Vordergrundfarbe (XBP_PP_HILITE_FGCOL)
* Der Aufbau des Browses unterscheidet sich jetzt kaum mehr vom Standard
*******************************************************************

#include "Appevent.ch"
#include "Common.ch"
#include "Gra.ch"
#include "Xbp.ch"
#pragma Library( "XppUi2.lib" )

#define CRLF Chr(13)+Chr(10)

STATIC aData
STATIC nLastRec
STATIC nRecno

PROCEDURE AppSys; RETURN

FUNCTION Main()
LOCAL oDlg, oBrowse, oColumn, oXbp, mp1, mp2, nEvent, aPres, aColPres

aPres := ;
  { { XBP_PP_COL_DA_ROWHEIGHT, 30 }, ; // hher, weil ggf. zweizeilig
    { XBP_PP_COL_DA_CELLHEIGHT, 30 }, ;
    { XBP_PP_COL_DA_ROWSEPARATOR, IF(IsThemeActive(),XBPCOL_SEP_LINE,XBPCOL_SEP_NONE) }, ;
    { XBP_PP_COL_DA_COLSEPARATOR, IF(IsThemeActive(),XBPCOL_SEP_LINE,XBPCOL_SEP_NONE) }, ;
    { XBP_PP_HILITE_BGCLR, GraMakeRGBColor({136,170,214}) }, ;
    { XBP_PP_HILITE_FGCLR, GraMakeRGBColor({255,102,51}) }, ;
    { XBP_PP_COL_DA_CELLFRAMELAYOUT, XBPFRAME_BOX+XBPFRAME_RECESSED }, ;
    { XBP_PP_COL_FA_FRAMELAYOUT, XBPFRAME_BOX+XBPFRAME_RECESSED }, ;
    { XBP_PP_COL_DA_FRAMELAYOUT, XBPFRAME_NONE }, ;
    { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK } , ;
    { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE } }

aColPres := aClone(aPres)
aAdd(aPres,   { XBP_PP_COL_DA_CELLALIGNMENT, XBPALIGN_LEFT+XBPALIGN_VCENTER })
aAdd(aColPres,{ XBP_PP_COL_DA_CELLALIGNMENT, XBPALIGN_RIGHT+XBPALIGN_VCENTER })

aData := {{1,'grn'   ,'Maier'  ,'Berlin'+CRLF+'Kurfrstendamm' },;
          {2,'gelb'   ,'Mller' ,'Berlin'+CRLF+'Adenauer Platz' },;
          {3,'blau'   ,'Schulze','Berlin'+CRLF+'Kottbusser Damm' },;
          {4,'grn'   ,'Albers' ,'Hamburg'+CRLF+'Mnkebergstrae'},;
          {5,'rot'    ,'Mayer'  ,'Mnchen'+CRLF+'Viktualienmarkt'},;
          {6,'schwarz','Kabel'  ,'Kln'+CRLF+'Am Dom'}}

nRecno := 1
nLastRec := Len(aData)

oDlg := XbpDialog():new(,,,,, .F. )
   oDlg:taskList                 := .T.
   oDlg:clientSize               := { 700, 500 }
   oDlg:drawingArea:clipChildren := .T.
   oDlg:title                    := 'Beispiel 6'
   oDlg:create()
   oDlg:drawingArea:setFontCompoundName( '9.Arial' )
   CenterControl( oDlg )
   SetAppWindow( oDlg )

oBrowse := XbpBrowseCustom():new( oDlg:drawingArea,, { 0, 0 }, oDlg:drawingArea:currentSize(),, .F. )
  oBrowse:SkipBlock     := {|nSkip,oBrowse| DoSkip(nSkip,oBrowse) }
  oBrowse:GoBottomBlock := {|| nRecno := Len(aData) }
  oBrowse:GoTopBlock    := {|| nRecno := 1 }
  oBrowse:PosBlock      := {|| nRecno }
  oBrowse:PhyPosBlock   := {|| nRecno }
  oBrowse:LastPosBlock  := {|| Len(aData) }
  oBrowse:FirstPosBlock := {|| 1 }
  oBrowse:CursorMode    := XBPBRW_CURSOR_ROW
  oBrowse:SetPresParam(aPres)
  oBrowse:create()

   * 1. Spalte
   oColumn := oBrowse:AddColumn( {|| aData[nRecno,1]}, 10, "Nummer" )
   * 2. Spalte
   oColumn := oBrowse:AddColumn( {|| aData[nRecno,2]}, 10, "Farbe" )
   oColumn:Configure(,,,,aColPres,.T.)
   oColumn:ColorBlock := {|x|{MyGetColor(x),GRA_CLR_WHITE}}
   * 3. Spalte
   oColumn := oBrowse:AddColumn( {|| aData[nRecno,3]}, 20, "Name" )
   oColumn:ColorBlock := {||{GRA_CLR_BLUE,GRA_CLR_YELLOW}}
   * 4. Spalte
   oColumn := oBrowse:AddColumn( {|| aData[nRecno,4]}, 20, "Ort" )

oBrowse:show()
oDlg:show()

DO WHILE nEvent <> xbeP_Close
   nEvent := AppEvent( @mp1, @mp2, @oXbp )
   oXbp:handleEvent( nEvent, mp1, mp2 )
ENDDO
QUIT
RETURN NIL

***************************************
CLASS XbpBrowseCustom FROM XbpBrowse
***************************************
PROTECTED:
   VAR oFontNormal
   VAR oFontHilite
   VAR oFontSmall
   VAR oFontSmallHilite
   VAR oBerlinIcon
   VAR aLineAttrs

EXPORTED:
   METHOD CustomDrawCell

   INLINE METHOD destroy
   *********************
      ::XbpBrowse:destroy()
   RETURN self

   INLINE METHOD init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   *****************************************************************
      ::XbpBrowse:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
      ::drawMode:= XBP_DRAW_OWNER
      ::oFontNormal      := XbpFont():New():Create("9.Arial")
      ::oFontSmall       := XbpFont():New():Create("8.Arial")
      ::oFontHilite      := XbpFont():New():Create("9.Arial Fett")
      ::oFontSmallHilite := XbpFont():New():Create("8.Arial Fett Kursiv")

      ::oBerlinIcon      := XbpIcon():New():Create()
      ::oBerlinIcon:Load("icons.dll",1,24,24)

      ::aLineAttrs := Array(GRA_AL_COUNT)
      ::aLineAttrs [ GRA_AL_WIDTH ]  := GRA_LINEWIDTH_NORMAL
      ::aLineAttrs [ GRA_AL_COLOR ]  := GRA_CLR_DARKGRAY
      ::aLineAttrs [ GRA_AL_TYPE ]   := GRA_LINETYPE_DOT


   RETURN self

   INLINE METHOD create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   *******************************************************************
      ::XbpBrowse:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   RETURN self

ENDCLASS

METHOD XbpBrowseCustom:customDrawCell( oPS, aInfo )
* Erhebt das Alignment, die Vordergrundfarbe und zeichnet dann den Zellinhalt selbst
LOCAL xData, nFgCol, nAlign := XBPALIGN_VCENTER+XBPALIGN_HCENTER, aPP, nFound, xData1, xData2,;
      oArea := aInfo[ XBP_DRAWINFO_AREA ]


* Zellinhalt erheben:
xData:= oArea:GetCell( aInfo[ XBP_DRAWINFO_ITEM ] )
IF xData = nil .or. !32 $ aInfo[ XBP_DRAWINFO_ACTION ] // nur selbst zeichnen, wenn Inhalt vorhanden und Vordergrund gezeichnet werden muss!
  RETURN .T.
ENDIF

* Vordergrundfarbe erheben:
oArea:GetCellColor( aInfo[ XBP_DRAWINFO_ITEM ],@nFgCol )
* und fr den Presentation Space setzen:
oPs:SetColor(nFgCol)

* Font setzen abhngig davon, ob selektiert oder nicht:
IF aInfo[XBP_DRAWINFO_STATE] = XBP_DRAWSTATE_SELECTED
  oPs:SetFont(::oFontHilite)
  ELSE
  oPs:SetFont(::oFontNormal)
ENDIF


* Alignment der Spalte erheben:
aPP := oArea:SetParent():SetPresParam()
nFound := AScan(aPP,{|a|Valtype(a[1])=='N' .AND. a[1]==XBP_PP_COL_DA_CELLALIGNMENT } )
IF nFound > 0 .and. aPP[nFound,2] <> nil
  nAlign := aPP[nFound,2]
ENDIF

* Aktive Zellen in Vordergrundfarbe XBP_PP_HILITE_FGCLR anzeigen!
IF aInfo[XBP_DRAWINFO_STATE] = XBP_DRAWSTATE_SELECTED
  nFound := AScan(aPP,{|a|Valtype(a[1])=='N' .AND. (a[1]==XBPCOL_DA_HILITE_FGCLR+XBP_PP_COL_DA_BASE) } ) // XBP_PP_HILITE_FGCLR
  IF nFound > 0 .and. aPP[nFound,2] <> nil
    oPs:SetColor(aPP[nFound,2])
  ENDIF
ENDIF

* Text anzeigen (der eigentliche Kern der Angelegenheit):
xData := Var2Char(xData) // Spalte 1 ist numerisch
IF CRLF $ xData // enthlt einen Zeilenumbruch
  xData1 := Trim(Left(xData,At(CRLF,xData)-1))
  xData2 := Trim(SubStr(xData,At(CRLF,xData)+2,Len(xData)-(At(CRLF,xData))))
  GraCaptionStr( oPS, { aInfo[ XBP_DRAWINFO_RECT, 1 ], aInfo[ XBP_DRAWINFO_RECT, 2 ]+15 }, { aInfo[ XBP_DRAWINFO_RECT, 3 ], aInfo[ XBP_DRAWINFO_RECT, 4 ] }, xData1, nAlign )
  IF "Berlin" $ xData // Icon rechtsbndig anzeigen
    ::oBerlinIcon:Draw(oPs,{ aInfo[ XBP_DRAWINFO_RECT, 3 ]-26, aInfo[ XBP_DRAWINFO_RECT, 2 ], aInfo[ XBP_DRAWINFO_RECT, 3 ]-2, aInfo[ XBP_DRAWINFO_RECT, 2 ]+24 })
  ENDIF
  IF aInfo[XBP_DRAWINFO_STATE] = XBP_DRAWSTATE_SELECTED
    oPs:SetFont(::oFontSmallHilite)
    ELSE
    oPs:SetFont(::oFontSmall)
  ENDIF
  GraCaptionStr( oPS, { aInfo[ XBP_DRAWINFO_RECT, 1 ], aInfo[ XBP_DRAWINFO_RECT, 2 ] }, { aInfo[ XBP_DRAWINFO_RECT, 3 ], aInfo[ XBP_DRAWINFO_RECT, 2 ]+15 }, xData2, nAlign )
  ELSE
  GraCaptionStr( oPS, aInfo[ XBP_DRAWINFO_RECT ], { aInfo[ XBP_DRAWINFO_RECT, 3 ], aInfo[ XBP_DRAWINFO_RECT, 4 ] }, xData, nAlign )
ENDIF
* und noch eine Trennlinie:
GraSetAttrLine( oPS, ::aLineAttrs )
GraLine(oPs,{ aInfo[ XBP_DRAWINFO_RECT,1 ]-3,aInfo[ XBP_DRAWINFO_RECT,2 ]-3},{aInfo[ XBP_DRAWINFO_RECT,3 ]+3,aInfo[ XBP_DRAWINFO_RECT,2 ]-3 } )

* Rckgabe .T. wrde bewirken, dass die Zelle berzeichnet wird! (Einfach mal ausprobieren!)
RETURN .F.

******************************************************


STATIC FUNCTION MyGetColor(x)
DO CASE
  CASE x = 'grn'
  RETURN GRA_CLR_GREEN
  CASE x = 'gelb'
  RETURN GRA_CLR_YELLOW
  CASE x = 'blau'
  RETURN GRA_CLR_BLUE
  CASE x = 'rot'
  RETURN GRA_CLR_RED
  CASE x = 'schwarz'
  RETURN GRA_CLR_BLACK
ENDCASE
RETURN GRA_CLR_BLACK

FUNCTION DoSkip( nSkip )
LOCAL nCanSkip
  IF nRecno + nSkip < 1             // "BoF"
     nCanSkip := 1 - nRecno
  ELSEIF nRecno + nSkip > nLastRec  // "EoF"
     nCanSkip := nLastRec - nRecno
  ELSE
     nCanSkip := nSkip
  ENDIF
  nRecno += nCanSkip
RETURN nCanSkip

